#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

uniform sampler2D u_texture;

varying vec2 v_texCoord;
varying LOWP vec4 v_color;

void main()
{
    vec4 outColor = v_color * texture2D(u_texture, v_texCoord);
    float alpha = outColor.a;
    if (alpha > 0.0)
        gl_FragColor = vec4(alpha, outColor.r / alpha, outColor.g / alpha, outColor.b / alpha);
    else
        gl_FragColor = outColor.argb;
}