#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

uniform sampler2D u_texture;

varying vec2 v_texCoord;
varying vec2 v_blurTexCoords[4];
varying vec4 v_blurTexCoordsPacked[2];
varying LOWP vec4 v_color;
 
void main()
{
    vec4 summedColor = vec4(0.0);
    float overallAlpha = 0.0;
    int i = 0;
    vec4 fetchedColor;
    float scaleWithAlpha;

    // 0

    fetchedColor = texture2D(u_texture, v_texCoord);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;      // ADDED this to get unpremultiplied rgb, then used that with premultiply opengl blend mode, work
        scaleWithAlpha = fetchedColor.a * 0.2204;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    // 1

    fetchedColor = texture2D(u_texture, v_blurTexCoords[0]);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.19;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    fetchedColor = texture2D(u_texture, v_blurTexCoords[1]);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.19;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    // 2

    fetchedColor = texture2D(u_texture, v_blurTexCoords[2]);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.1216;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    fetchedColor = texture2D(u_texture, v_blurTexCoords[3]);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.1216;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    // 3 (NOW USING PACKED UV VARYING)

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[0].xy);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.0578;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[0].zw);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.0578;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    // 4

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[1].xy);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.0204;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[1].zw);
    if (fetchedColor.a > 0.0) {
        fetchedColor.rgb /= fetchedColor.a;
        scaleWithAlpha = fetchedColor.a * 0.0204;
        summedColor += fetchedColor * scaleWithAlpha;
        overallAlpha += scaleWithAlpha;
    }

    overallAlpha *= v_color.a;

    if (overallAlpha <= 0.0)
        discard;
    else {
        summedColor *= v_color.a;
        gl_FragColor = vec4(overallAlpha - summedColor.r, overallAlpha - summedColor.g, overallAlpha - summedColor.b, overallAlpha);
    }
}