#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

uniform sampler2D u_texture;
uniform LOWP vec3 u_glowRGB;
uniform float u_glowIntensity;

varying vec2 v_texCoord;
varying vec2 v_blurTexCoords[4];
varying vec4 v_blurTexCoordsPacked[2];
varying LOWP vec4 v_color;
 
void main()
{
    float overallAlpha = 0.0;
    vec4 fetchedColor;
    float scaleWithAlpha;

    // 0

    fetchedColor = texture2D(u_texture, v_texCoord);
    overallAlpha += fetchedColor.a * 0.2204;

    // 1

    fetchedColor = texture2D(u_texture, v_blurTexCoords[0]);
    overallAlpha += fetchedColor.a * 0.19;

    fetchedColor = texture2D(u_texture, v_blurTexCoords[1]);
    overallAlpha += fetchedColor.a * 0.19;

    // 2

    fetchedColor = texture2D(u_texture, v_blurTexCoords[2]);
    overallAlpha += fetchedColor.a * 0.1216;

    fetchedColor = texture2D(u_texture, v_blurTexCoords[3]);
    overallAlpha += fetchedColor.a * 0.1216;

    // 3 (NOW USING PACKED UV VARYING)

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[0].xy);
    overallAlpha += fetchedColor.a * 0.0578;

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[0].zw);
    overallAlpha += fetchedColor.a * 0.0578;

    // 4

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[1].xy);
    overallAlpha += fetchedColor.a * 0.0204;

    fetchedColor = texture2D(u_texture, v_blurTexCoordsPacked[1].zw);
    overallAlpha += fetchedColor.a * 0.0204;

    overallAlpha = clamp(overallAlpha * (v_color.a * u_glowIntensity), 0.0, 1.0);

    if (overallAlpha <= 0.0)
        discard;
    else
        gl_FragColor = vec4(u_glowRGB.rgb * overallAlpha, overallAlpha);
}