#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

uniform sampler2D u_texture;
uniform LOWP vec4 u_outlineRGB;
uniform vec2 u_normalizedOutlineThickness;
uniform float u_steps;

varying vec2 v_texCoord;
varying LOWP vec4 v_color;
 
void main() {
    const float TAU = 6.28318530;
    vec4 texel = texture2D(u_texture, v_texCoord);

    vec4 fragColor = vec4(0, 0, 0, 0);

    if (texel.a > 0.1) {
        fragColor = texel;
    } else {
        for (float i = 0.0; i < TAU; i += TAU / u_steps) {
            // Sample image in a circular pattern
            vec2 offset = vec2(sin(i), cos(i)) * u_normalizedOutlineThickness;
            vec4 col = texture2D(u_texture, v_texCoord + offset);

            // Mix outline with background
            //float alpha = col.a;//smoothstep(0.5, 0.7, distance(col.a, target));
            fragColor = mix(fragColor, u_outlineRGB, col.a);
        }
        fragColor.rgb *= fragColor.a;
    }

    fragColor.rgba *= v_color.a;
    gl_FragColor = fragColor;
}