#ifdef GL_ES
precision highp float; // necessary, as on devices (Android at least) there is flickering due to inprecision
#endif

uniform sampler2D u_texture;
uniform float u_blockSize;
uniform float u_texWidth;
uniform float u_texHeight;

varying vec2 v_texCoord;
varying vec4 v_color;

void main() {
    vec2 blockSize = vec2(u_blockSize, u_blockSize);
    vec2 texSize = vec2(u_texWidth, u_texHeight);
    vec2 coords = vec2(v_texCoord * texSize);
    vec2 pixelCoords = vec2(floor(coords / blockSize) * blockSize) / texSize;
    vec4 out_color = texture2D(u_texture, pixelCoords);
    gl_FragColor = v_color * out_color;
}