#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

varying vec2 v_texCoord;
varying LOWP vec4 v_color;

uniform sampler2D u_texture;
uniform vec3 u_removeColor;
uniform float u_threshold;
uniform float u_spread;

void main() {
    vec4 texColor = texture2D(u_texture, v_texCoord);
    vec3 colorDiff = abs(texColor.rgb - u_removeColor);

    // Threshold to determine if the color should be replaced with transparency
    // If the color difference is below the threshold, set the alpha channel to 0.0 (transparent)
    //	float alpha = all(lessThanEqual(colorDiff, vec3(threshold))) ? 0.0 : 1.0;
    float alpha = smoothstep(u_threshold * u_spread, u_threshold, length(colorDiff));
    gl_FragColor = vec4(texColor.rgb, alpha * texColor.a) * v_color;
}