#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

uniform sampler2D u_texture;
uniform float u_scale;
uniform float u_textAlpha;
uniform float u_spread;
uniform float u_viewportScale;

varying vec4 v_color;
varying vec2 v_texCoord;

void main() {
    float distance = texture2D(u_texture, v_texCoord).a;
    float smoothing = 0.25 / (u_spread * (u_scale * u_viewportScale));
    float alpha = smoothstep(0.5 - smoothing, 0.5 + smoothing, distance);
    alpha *= u_textAlpha;
    gl_FragColor = vec4(v_color.rgb * alpha, alpha);
}